/*!
 * (C) Emu Analytics
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-df77e04f.js');
const theme = require('./theme-a17302d3.js');
const component = require('./component-46323ab5.js');
const contextRegistry = require('./context-registry-2412f040.js');
require('./foundation-e2572577.js');
require('./component-c023df31.js');
require('./events-b8821294.js');
require('./ponyfill-7c9483f1.js');
require('./flow-core-context-9645d5e4.js');
require('./debug-490602eb.js');

const buttonCss = ":host{position:relative;box-sizing:border-box}:host *,:host *:before,:host *:after{box-sizing:inherit}.mdc-touch-target-wrapper{display:inline}.mdc-elevation-overlay{position:absolute;border-radius:inherit;opacity:0;pointer-events:none;transition:opacity 280ms cubic-bezier(0.4, 0, 0.2, 1);background-color:#fff}.mdc-button{-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-family:Roboto, sans-serif;font-family:var(--mdc-typography-button-font-family, var(--mdc-typography-font-family, Roboto, sans-serif));font-size:0.875rem;font-size:var(--mdc-typography-button-font-size, 0.875rem);line-height:2.25rem;line-height:var(--mdc-typography-button-line-height, 2.25rem);font-weight:500;font-weight:var(--mdc-typography-button-font-weight, 500);letter-spacing:0.0892857143em;letter-spacing:var(--mdc-typography-button-letter-spacing, 0.0892857143em);text-decoration:none;text-decoration:var(--mdc-typography-button-text-decoration, none);text-transform:uppercase;text-transform:var(--mdc-typography-button-text-transform, uppercase);padding:0 8px 0 8px;position:relative;display:inline-flex;align-items:center;justify-content:center;box-sizing:border-box;min-width:64px;border:none;outline:none;line-height:inherit;user-select:none;-webkit-appearance:none;overflow:visible;vertical-align:middle;border-radius:4px;border-radius:var(--mdc-shape-small, 4px);height:36px}.mdc-button .mdc-elevation-overlay{width:100%;height:100%;top:0;left:0}.mdc-button::-moz-focus-inner{padding:0;border:0}.mdc-button:active{outline:none}.mdc-button:hover{cursor:pointer}.mdc-button:disabled{cursor:default;pointer-events:none}.mdc-button .mdc-button__ripple{border-radius:4px;border-radius:var(--mdc-shape-small, 4px)}.mdc-button:not(:disabled){background-color:transparent}.mdc-button:disabled{background-color:transparent}.mdc-button .mdc-button__icon{margin-left:0;margin-right:8px;display:inline-block;width:18px;height:18px;font-size:18px;vertical-align:top}[dir=rtl] .mdc-button .mdc-button__icon,.mdc-button .mdc-button__icon[dir=rtl]{margin-left:8px;margin-right:0}.mdc-button .mdc-button__touch{position:absolute;top:50%;right:0;height:48px;left:0;transform:translateY(-50%)}.mdc-button:not(:disabled){color:#6200ee;color:var(--mdc-theme-primary, #6200ee)}.mdc-button:disabled{color:rgba(0, 0, 0, 0.38)}.mdc-button__label+.mdc-button__icon{margin-left:8px;margin-right:0}[dir=rtl] .mdc-button__label+.mdc-button__icon,.mdc-button__label+.mdc-button__icon[dir=rtl]{margin-left:0;margin-right:8px}svg.mdc-button__icon{fill:currentColor}.mdc-button--raised .mdc-button__icon,.mdc-button--unelevated .mdc-button__icon,.mdc-button--outlined .mdc-button__icon{margin-left:-4px;margin-right:8px}[dir=rtl] .mdc-button--raised .mdc-button__icon,.mdc-button--raised .mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--unelevated .mdc-button__icon,.mdc-button--unelevated .mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--outlined .mdc-button__icon,.mdc-button--outlined .mdc-button__icon[dir=rtl]{margin-left:8px;margin-right:-4px}.mdc-button--raised .mdc-button__label+.mdc-button__icon,.mdc-button--unelevated .mdc-button__label+.mdc-button__icon,.mdc-button--outlined .mdc-button__label+.mdc-button__icon{margin-left:8px;margin-right:-4px}[dir=rtl] .mdc-button--raised .mdc-button__label+.mdc-button__icon,.mdc-button--raised .mdc-button__label+.mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--unelevated .mdc-button__label+.mdc-button__icon,.mdc-button--unelevated .mdc-button__label+.mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--outlined .mdc-button__label+.mdc-button__icon,.mdc-button--outlined .mdc-button__label+.mdc-button__icon[dir=rtl]{margin-left:-4px;margin-right:8px}.mdc-button--raised,.mdc-button--unelevated{padding:0 16px 0 16px}.mdc-button--raised:not(:disabled),.mdc-button--unelevated:not(:disabled){background-color:#6200ee;background-color:var(--mdc-theme-primary, #6200ee)}.mdc-button--raised:not(:disabled),.mdc-button--unelevated:not(:disabled){color:#fff;color:var(--mdc-theme-on-primary, #fff)}.mdc-button--raised:disabled,.mdc-button--unelevated:disabled{background-color:rgba(0, 0, 0, 0.12)}.mdc-button--raised:disabled,.mdc-button--unelevated:disabled{color:rgba(0, 0, 0, 0.38)}.mdc-button--raised{box-shadow:0px 3px 1px -2px rgba(0, 0, 0, 0.2), 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 1px 5px 0px rgba(0, 0, 0, 0.12);transition:box-shadow 280ms cubic-bezier(0.4, 0, 0.2, 1)}.mdc-button--raised:hover,.mdc-button--raised:focus{box-shadow:0px 2px 4px -1px rgba(0, 0, 0, 0.2), 0px 4px 5px 0px rgba(0, 0, 0, 0.14), 0px 1px 10px 0px rgba(0, 0, 0, 0.12)}.mdc-button--raised:active{box-shadow:0px 5px 5px -3px rgba(0, 0, 0, 0.2), 0px 8px 10px 1px rgba(0, 0, 0, 0.14), 0px 3px 14px 2px rgba(0, 0, 0, 0.12)}.mdc-button--raised:disabled{box-shadow:0px 0px 0px 0px rgba(0, 0, 0, 0.2), 0px 0px 0px 0px rgba(0, 0, 0, 0.14), 0px 0px 0px 0px rgba(0, 0, 0, 0.12)}.mdc-button--outlined{padding:0 15px 0 15px;border-width:1px;border-style:solid}.mdc-button--outlined .mdc-button__ripple{top:-1px;left:-1px;border:1px solid transparent}.mdc-button--outlined .mdc-button__touch{left:-1px;width:calc(100% + 2 * 1px)}.mdc-button--outlined:not(:disabled){border-color:rgba(0, 0, 0, 0.12)}.mdc-button--outlined:disabled{border-color:rgba(0, 0, 0, 0.12)}.mdc-button--touch{margin-top:6px;margin-bottom:6px}@keyframes mdc-ripple-fg-radius-in{from{animation-timing-function:cubic-bezier(0.4, 0, 0.2, 1);transform:translate(var(--mdc-ripple-fg-translate-start, 0)) scale(1)}to{transform:translate(var(--mdc-ripple-fg-translate-end, 0)) scale(var(--mdc-ripple-fg-scale, 1))}}@keyframes mdc-ripple-fg-opacity-in{from{animation-timing-function:linear;opacity:0}to{opacity:var(--mdc-ripple-fg-opacity, 0)}}@keyframes mdc-ripple-fg-opacity-out{from{animation-timing-function:linear;opacity:var(--mdc-ripple-fg-opacity, 0)}to{opacity:0}}.mdc-button{--mdc-ripple-fg-size:0;--mdc-ripple-left:0;--mdc-ripple-top:0;--mdc-ripple-fg-scale:1;--mdc-ripple-fg-translate-end:0;--mdc-ripple-fg-translate-start:0;-webkit-tap-highlight-color:rgba(0, 0, 0, 0)}.mdc-button .mdc-button__ripple::before,.mdc-button .mdc-button__ripple::after{position:absolute;border-radius:50%;opacity:0;pointer-events:none;content:\"\"}.mdc-button .mdc-button__ripple::before{transition:opacity 15ms linear, background-color 15ms linear;z-index:1}.mdc-button.mdc-ripple-upgraded .mdc-button__ripple::before{transform:scale(var(--mdc-ripple-fg-scale, 1))}.mdc-button.mdc-ripple-upgraded .mdc-button__ripple::after{top:0;left:0;transform:scale(0);transform-origin:center center}.mdc-button.mdc-ripple-upgraded--unbounded .mdc-button__ripple::after{top:var(--mdc-ripple-top, 0);left:var(--mdc-ripple-left, 0)}.mdc-button.mdc-ripple-upgraded--foreground-activation .mdc-button__ripple::after{animation:mdc-ripple-fg-radius-in 225ms forwards, mdc-ripple-fg-opacity-in 75ms forwards}.mdc-button.mdc-ripple-upgraded--foreground-deactivation .mdc-button__ripple::after{animation:mdc-ripple-fg-opacity-out 150ms;transform:translate(var(--mdc-ripple-fg-translate-end, 0)) scale(var(--mdc-ripple-fg-scale, 1))}.mdc-button .mdc-button__ripple::before,.mdc-button .mdc-button__ripple::after{top:calc(50% - 100%);left:calc(50% - 100%);width:200%;height:200%}.mdc-button.mdc-ripple-upgraded .mdc-button__ripple::after{width:var(--mdc-ripple-fg-size, 100%);height:var(--mdc-ripple-fg-size, 100%)}.mdc-button .mdc-button__ripple::before,.mdc-button .mdc-button__ripple::after{background-color:#6200ee;background-color:var(--mdc-theme-primary, #6200ee)}.mdc-button:hover .mdc-button__ripple::before{opacity:0.04}.mdc-button.mdc-ripple-upgraded--background-focused .mdc-button__ripple::before,.mdc-button:not(.mdc-ripple-upgraded):focus .mdc-button__ripple::before{transition-duration:75ms;opacity:0.12}.mdc-button:not(.mdc-ripple-upgraded) .mdc-button__ripple::after{transition:opacity 150ms linear}.mdc-button:not(.mdc-ripple-upgraded):active .mdc-button__ripple::after{transition-duration:75ms;opacity:0.12}.mdc-button.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.12}.mdc-button .mdc-button__ripple{position:absolute;box-sizing:content-box;width:100%;height:100%;overflow:hidden}.mdc-button:not(.mdc-button--outlined) .mdc-button__ripple{top:0;left:0}.mdc-button--raised .mdc-button__ripple::before,.mdc-button--raised .mdc-button__ripple::after,.mdc-button--unelevated .mdc-button__ripple::before,.mdc-button--unelevated .mdc-button__ripple::after{background-color:#fff;background-color:var(--mdc-theme-on-primary, #fff)}.mdc-button--raised:hover .mdc-button__ripple::before,.mdc-button--unelevated:hover .mdc-button__ripple::before{opacity:0.08}.mdc-button--raised.mdc-ripple-upgraded--background-focused .mdc-button__ripple::before,.mdc-button--raised:not(.mdc-ripple-upgraded):focus .mdc-button__ripple::before,.mdc-button--unelevated.mdc-ripple-upgraded--background-focused .mdc-button__ripple::before,.mdc-button--unelevated:not(.mdc-ripple-upgraded):focus .mdc-button__ripple::before{transition-duration:75ms;opacity:0.24}.mdc-button--raised:not(.mdc-ripple-upgraded) .mdc-button__ripple::after,.mdc-button--unelevated:not(.mdc-ripple-upgraded) .mdc-button__ripple::after{transition:opacity 150ms linear}.mdc-button--raised:not(.mdc-ripple-upgraded):active .mdc-button__ripple::after,.mdc-button--unelevated:not(.mdc-ripple-upgraded):active .mdc-button__ripple::after{transition-duration:75ms;opacity:0.24}.mdc-button--raised.mdc-ripple-upgraded,.mdc-button--unelevated.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.24}.mdc-icon-button{display:inline-block;position:relative;box-sizing:border-box;border:none;outline:none;background-color:transparent;fill:currentColor;color:inherit;font-size:24px;text-decoration:none;cursor:pointer;user-select:none;width:48px;height:48px;padding:12px}.mdc-icon-button svg,.mdc-icon-button img{width:24px;height:24px}.mdc-icon-button:disabled{color:rgba(0, 0, 0, 0.38);color:var(--mdc-theme-text-disabled-on-light, rgba(0, 0, 0, 0.38))}.mdc-icon-button:disabled{cursor:default;pointer-events:none}.mdc-icon-button__icon{display:inline-block}.mdc-icon-button__icon.mdc-icon-button__icon--on{display:none}.mdc-icon-button--on .mdc-icon-button__icon{display:none}.mdc-icon-button--on .mdc-icon-button__icon.mdc-icon-button__icon--on{display:inline-block}.mdc-icon-button{--mdc-ripple-fg-size:0;--mdc-ripple-left:0;--mdc-ripple-top:0;--mdc-ripple-fg-scale:1;--mdc-ripple-fg-translate-end:0;--mdc-ripple-fg-translate-start:0;-webkit-tap-highlight-color:rgba(0, 0, 0, 0)}.mdc-icon-button::before,.mdc-icon-button::after{position:absolute;border-radius:50%;opacity:0;pointer-events:none;content:\"\"}.mdc-icon-button::before{transition:opacity 15ms linear, background-color 15ms linear;z-index:1}.mdc-icon-button.mdc-ripple-upgraded::before{transform:scale(var(--mdc-ripple-fg-scale, 1))}.mdc-icon-button.mdc-ripple-upgraded::after{top:0;left:0;transform:scale(0);transform-origin:center center}.mdc-icon-button.mdc-ripple-upgraded--unbounded::after{top:var(--mdc-ripple-top, 0);left:var(--mdc-ripple-left, 0)}.mdc-icon-button.mdc-ripple-upgraded--foreground-activation::after{animation:mdc-ripple-fg-radius-in 225ms forwards, mdc-ripple-fg-opacity-in 75ms forwards}.mdc-icon-button.mdc-ripple-upgraded--foreground-deactivation::after{animation:mdc-ripple-fg-opacity-out 150ms;transform:translate(var(--mdc-ripple-fg-translate-end, 0)) scale(var(--mdc-ripple-fg-scale, 1))}.mdc-icon-button::before,.mdc-icon-button::after{top:calc(50% - 50%);left:calc(50% - 50%);width:100%;height:100%}.mdc-icon-button.mdc-ripple-upgraded::before,.mdc-icon-button.mdc-ripple-upgraded::after{top:var(--mdc-ripple-top, calc(50% - 50%));left:var(--mdc-ripple-left, calc(50% - 50%));width:var(--mdc-ripple-fg-size, 100%);height:var(--mdc-ripple-fg-size, 100%)}.mdc-icon-button.mdc-ripple-upgraded::after{width:var(--mdc-ripple-fg-size, 100%);height:var(--mdc-ripple-fg-size, 100%)}.mdc-icon-button::before,.mdc-icon-button::after{background-color:#000}.mdc-icon-button:hover::before{opacity:0.04}.mdc-icon-button.mdc-ripple-upgraded--background-focused::before,.mdc-icon-button:not(.mdc-ripple-upgraded):focus::before{transition-duration:75ms;opacity:0.12}.mdc-icon-button:not(.mdc-ripple-upgraded)::after{transition:opacity 150ms linear}.mdc-icon-button:not(.mdc-ripple-upgraded):active::after{transition-duration:75ms;opacity:0.12}.mdc-icon-button.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.12}:host{display:inline-flex;vertical-align:middle;pointer-events:none;--flow-color-base:var(--flow-color-gray, #92949c);--flow-color-base-rgb:var(--flow-color-gray-rgb, 146, 148, 156);--flow-color-contrast:var(--flow-color-gray-contrast, #ffffff);--flow-color-contrast-rgb:var(\n    --flow-color-gray-contrast-rgb,\n    255, 255, 255\n  ) !important;--flow-color-shade:var(--flow-color-gray-shade, #75767d);--flow-color-tint:var(--flow-color-gray-tint, #a8a9b0);--color:var(--flow-color-base);--text-color:var(--flow-color-contrast)}:host(:focus){outline:none}.mdc-button{width:inherit}.mdc-button,.mdc-icon-button{pointer-events:all}.mdc-button,.mdc-icon-button{--mdc-typography-font-family:var(--flow-font-sans, -apple-system, BlinkMacSystemFont, Segoe UI, Roboto, Helvetica, Arial, sans-serif, Apple Color Emoji, Segoe UI Emoji, Segoe UI Symbol)}.mdc-button:not(:disabled),.mdc-icon-button:not(:disabled){color:var(--color)}.mdc-button:not(:disabled),.mdc-icon-button:not(:disabled){border-color:var(--color)}.mdc-button:disabled,.mdc-icon-button:disabled{color:var(--flow-color-step-500)}.mdc-button:disabled,.mdc-icon-button:disabled{border-color:var(--flow-color-step-500)}.mdc-button.mdc-button--raised:not(:disabled),.mdc-button.mdc-button--unelevated:not(:disabled){color:var(--text-color)}.mdc-button.mdc-button--raised:not(:disabled),.mdc-button.mdc-button--unelevated:not(:disabled){border-color:var(--text-color)}.mdc-button.mdc-button--raised:not(:disabled),.mdc-button.mdc-button--unelevated:not(:disabled){background-color:var(--color)}.mdc-button.mdc-button--raised:disabled,.mdc-button.mdc-button--unelevated:disabled{color:var(--flow-color-step-50)}.mdc-button.mdc-button--raised:disabled,.mdc-button.mdc-button--unelevated:disabled{background-color:var(--flow-color-step-300)}.mdc-button .mdc-button__ripple::before,.mdc-button .mdc-button__ripple::after,.mdc-icon-button::before,.mdc-icon-button::after{background-color:var(--color)}.mdc-button--raised .mdc-button__ripple::before,.mdc-button--raised .mdc-button__ripple::after,.mdc-button--unelevated .mdc-button__ripple::before,.mdc-button--unelevated .mdc-button__ripple::after{background-color:var(--text-color)}.mdc-button .mdc-button__label{line-height:normal}.mdc-button--outlined[disabled]:not(:disabled),.mdc-icon-button[disabled]:not(:disabled){color:red}.mdc-button--outlined[disabled]:not(:disabled),.mdc-icon-button[disabled]:not(:disabled){border-color:red}.mdc-button.mdc-button--compact{height:24px;margin-top:0;margin-bottom:0;font-size:0.6rem}.mdc-button.mdc-button--compact .mdc-button__touch{display:none}.mdc-button.mdc-button--compact .mdc-button__icon{width:0.72rem;height:0.72rem}.mdc-icon-button.mdc-button--compact{width:32px;height:32px;padding:8px;font-size:16px}.mdc-icon-button.mdc-button--compact svg,.mdc-icon-button.mdc-button--compact img{width:16px;height:16px}::slotted(flow-badge){position:absolute;z-index:var(--flow-z-index-tooltip, 1000);top:calc(var(--flow-font-size-x-small, 0.75rem) * -0.5);right:calc(var(--flow-font-size-x-small, 0.75rem) * -0.5)}";

const Button = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Set to `true` to display a smaller-sized button with reduced margins.
     */
    this.compact = false;
    /**
     * Set to `true` to disable interaction with the button.
     */
    this.disabled = false;
    /**
     * Set to `true` to display an 'icon-only' button with no button body or label. Note that
     * the default color of an 'icon-only' button is the current text color. Use the `color` property
     * to select a different color from the application palette.
     */
    this.iconButton = false;
    /**
     * Set to display an 'outlined' button.
     */
    this.outlined = false;
    /**
     * Set to display a 'solid' button.
     */
    this.solid = false;
    /**
     * Set to `true` to display the icon *after* the label (to the right in LTR mode).
     */
    this.trailingIcon = false;
    /** Set to 'true' to indicate that activating the button should submit the form. Ignored when `href` is set. */
    this.submit = false;
  }
  componentDidLoad() {
    this.ripple = new component.MDCRipple(this.button);
    this.ripple.unbounded = this.iconButton;
    // Workaround for Firefox - doesn't support delegatesFocus
    this.el.focus = () => this.button.focus();
  }
  handleClick(ev) {
    // Prevent propagation of event if button is disabled
    if (this.disabled) {
      ev.preventDefault();
      ev.stopImmediatePropagation();
    }
  }
  render() {
    const { label, color, disabled, icon, trailingIcon } = this;
    const isLink = !!this.href;
    const Button = isLink ? 'a' : 'button';
    const hostClasses = Object.assign({}, theme.createColorClasses(color));
    const nativeClasses = {
      'mdc-button': !this.iconButton,
      'mdc-icon-button': this.iconButton,
      'mdc-button--unelevated': this.solid,
      'mdc-button--outlined': this.outlined,
      'mdc-button--compact': this.compact
    };
    const iconClasses = {
      'mdc-button__icon': !this.iconButton,
      'mdc-icon-button__icon': this.iconButton
    };
    const iconDom = index.h("flow-icon", { part: "icon", class: iconClasses, icon: this.icon });
    return (index.h(index.Host, { class: hostClasses, onClick: this.handleClick }, index.h(Button, { ref: el => (this.button = el), class: nativeClasses, type: isLink ? null : this.submit ? 'submit' : 'button', disabled: disabled, href: isLink && this.href, target: isLink && this.target ? this.target : null, download: isLink && this.download ? this.download : null, rel: isLink && this.target ? 'noreferrer noopener' : null }, index.h("div", { class: "mdc-button__ripple" }), icon && !trailingIcon ? iconDom : undefined, index.h("span", { class: "mdc-button__label", part: "label" }, label ? label : index.h("slot", null)), icon && trailingIcon ? iconDom : undefined)));
  }
  static get delegatesFocus() { return true; }
  get el() { return index.getElement(this); }
};
Button.style = buttonCss;

const fabCss = ":root{--mdc-theme-primary:#6200ee;--mdc-theme-secondary:#018786;--mdc-theme-background:#fff;--mdc-theme-surface:#fff;--mdc-theme-error:#b00020;--mdc-theme-on-primary:#fff;--mdc-theme-on-secondary:#fff;--mdc-theme-on-surface:#000;--mdc-theme-on-error:#fff;--mdc-theme-text-primary-on-background:rgba(0, 0, 0, 0.87);--mdc-theme-text-secondary-on-background:rgba(0, 0, 0, 0.54);--mdc-theme-text-hint-on-background:rgba(0, 0, 0, 0.38);--mdc-theme-text-disabled-on-background:rgba(0, 0, 0, 0.38);--mdc-theme-text-icon-on-background:rgba(0, 0, 0, 0.38);--mdc-theme-text-primary-on-light:rgba(0, 0, 0, 0.87);--mdc-theme-text-secondary-on-light:rgba(0, 0, 0, 0.54);--mdc-theme-text-hint-on-light:rgba(0, 0, 0, 0.38);--mdc-theme-text-disabled-on-light:rgba(0, 0, 0, 0.38);--mdc-theme-text-icon-on-light:rgba(0, 0, 0, 0.38);--mdc-theme-text-primary-on-dark:white;--mdc-theme-text-secondary-on-dark:rgba(255, 255, 255, 0.7);--mdc-theme-text-hint-on-dark:rgba(255, 255, 255, 0.5);--mdc-theme-text-disabled-on-dark:rgba(255, 255, 255, 0.5);--mdc-theme-text-icon-on-dark:rgba(255, 255, 255, 0.5)}.mdc-theme--primary{color:#6200ee !important;color:var(--mdc-theme-primary, #6200ee) !important}.mdc-theme--secondary{color:#018786 !important;color:var(--mdc-theme-secondary, #018786) !important}.mdc-theme--background{background-color:#fff;background-color:var(--mdc-theme-background, #fff)}.mdc-theme--surface{background-color:#fff;background-color:var(--mdc-theme-surface, #fff)}.mdc-theme--error{color:#b00020 !important;color:var(--mdc-theme-error, #b00020) !important}.mdc-theme--on-primary{color:#fff !important;color:var(--mdc-theme-on-primary, #fff) !important}.mdc-theme--on-secondary{color:#fff !important;color:var(--mdc-theme-on-secondary, #fff) !important}.mdc-theme--on-surface{color:#000 !important;color:var(--mdc-theme-on-surface, #000) !important}.mdc-theme--on-error{color:#fff !important;color:var(--mdc-theme-on-error, #fff) !important}.mdc-theme--text-primary-on-background{color:rgba(0, 0, 0, 0.87) !important;color:var(--mdc-theme-text-primary-on-background, rgba(0, 0, 0, 0.87)) !important}.mdc-theme--text-secondary-on-background{color:rgba(0, 0, 0, 0.54) !important;color:var(--mdc-theme-text-secondary-on-background, rgba(0, 0, 0, 0.54)) !important}.mdc-theme--text-hint-on-background{color:rgba(0, 0, 0, 0.38) !important;color:var(--mdc-theme-text-hint-on-background, rgba(0, 0, 0, 0.38)) !important}.mdc-theme--text-disabled-on-background{color:rgba(0, 0, 0, 0.38) !important;color:var(--mdc-theme-text-disabled-on-background, rgba(0, 0, 0, 0.38)) !important}.mdc-theme--text-icon-on-background{color:rgba(0, 0, 0, 0.38) !important;color:var(--mdc-theme-text-icon-on-background, rgba(0, 0, 0, 0.38)) !important}.mdc-theme--text-primary-on-light{color:rgba(0, 0, 0, 0.87) !important;color:var(--mdc-theme-text-primary-on-light, rgba(0, 0, 0, 0.87)) !important}.mdc-theme--text-secondary-on-light{color:rgba(0, 0, 0, 0.54) !important;color:var(--mdc-theme-text-secondary-on-light, rgba(0, 0, 0, 0.54)) !important}.mdc-theme--text-hint-on-light{color:rgba(0, 0, 0, 0.38) !important;color:var(--mdc-theme-text-hint-on-light, rgba(0, 0, 0, 0.38)) !important}.mdc-theme--text-disabled-on-light{color:rgba(0, 0, 0, 0.38) !important;color:var(--mdc-theme-text-disabled-on-light, rgba(0, 0, 0, 0.38)) !important}.mdc-theme--text-icon-on-light{color:rgba(0, 0, 0, 0.38) !important;color:var(--mdc-theme-text-icon-on-light, rgba(0, 0, 0, 0.38)) !important}.mdc-theme--text-primary-on-dark{color:white !important;color:var(--mdc-theme-text-primary-on-dark, white) !important}.mdc-theme--text-secondary-on-dark{color:rgba(255, 255, 255, 0.7) !important;color:var(--mdc-theme-text-secondary-on-dark, rgba(255, 255, 255, 0.7)) !important}.mdc-theme--text-hint-on-dark{color:rgba(255, 255, 255, 0.5) !important;color:var(--mdc-theme-text-hint-on-dark, rgba(255, 255, 255, 0.5)) !important}.mdc-theme--text-disabled-on-dark{color:rgba(255, 255, 255, 0.5) !important;color:var(--mdc-theme-text-disabled-on-dark, rgba(255, 255, 255, 0.5)) !important}.mdc-theme--text-icon-on-dark{color:rgba(255, 255, 255, 0.5) !important;color:var(--mdc-theme-text-icon-on-dark, rgba(255, 255, 255, 0.5)) !important}.mdc-theme--primary-bg{background-color:#6200ee !important;background-color:var(--mdc-theme-primary, #6200ee) !important}.mdc-theme--secondary-bg{background-color:#018786 !important;background-color:var(--mdc-theme-secondary, #018786) !important}.mdc-touch-target-wrapper{display:inline}.mdc-elevation-overlay{position:absolute;border-radius:inherit;opacity:0;pointer-events:none;transition:opacity 280ms cubic-bezier(0.4, 0, 0.2, 1);background-color:#fff}.mdc-fab{position:relative;box-shadow:0px 3px 5px -1px rgba(0, 0, 0, 0.2), 0px 6px 10px 0px rgba(0, 0, 0, 0.14), 0px 1px 18px 0px rgba(0, 0, 0, 0.12);display:inline-flex;position:relative;align-items:center;justify-content:center;box-sizing:border-box;width:48px;height:48px;padding:0;border:none;fill:currentColor;text-decoration:none;cursor:pointer;user-select:none;-moz-appearance:none;-webkit-appearance:none;overflow:visible;transition:box-shadow 280ms cubic-bezier(0.4, 0, 0.2, 1), opacity 15ms linear 30ms, transform 270ms 0ms cubic-bezier(0, 0, 0.2, 1);background-color:#018786;background-color:var(--mdc-theme-secondary, #018786);color:#fff;color:var(--mdc-theme-on-secondary, #fff)}.mdc-fab .mdc-elevation-overlay{width:100%;height:100%;top:0;left:0}.mdc-fab:not(.mdc-fab--extended){border-radius:50%}.mdc-fab:not(.mdc-fab--extended) .mdc-fab__ripple{border-radius:50%}.mdc-fab::-moz-focus-inner{padding:0;border:0}.mdc-fab:hover,.mdc-fab:focus{box-shadow:0px 5px 5px -3px rgba(0, 0, 0, 0.2), 0px 8px 10px 1px rgba(0, 0, 0, 0.14), 0px 3px 14px 2px rgba(0, 0, 0, 0.12)}.mdc-fab:active{box-shadow:0px 7px 8px -4px rgba(0, 0, 0, 0.2), 0px 12px 17px 2px rgba(0, 0, 0, 0.14), 0px 5px 22px 4px rgba(0, 0, 0, 0.12)}.mdc-fab:active,.mdc-fab:focus{outline:none}.mdc-fab:hover{cursor:pointer}.mdc-fab>svg{width:100%}.mdc-fab .mdc-fab__icon{width:24px;height:24px;font-size:24px}.mdc-fab--mini{width:30px;height:30px}.mdc-fab--extended{-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-family:Roboto, sans-serif;font-family:var(--mdc-typography-button-font-family, var(--mdc-typography-font-family, Roboto, sans-serif));font-size:0.875rem;font-size:var(--mdc-typography-button-font-size, 0.875rem);line-height:2.25rem;line-height:var(--mdc-typography-button-line-height, 2.25rem);font-weight:500;font-weight:var(--mdc-typography-button-font-weight, 500);letter-spacing:0.0892857143em;letter-spacing:var(--mdc-typography-button-letter-spacing, 0.0892857143em);text-decoration:none;text-decoration:var(--mdc-typography-button-text-decoration, none);text-transform:uppercase;text-transform:var(--mdc-typography-button-text-transform, uppercase);border-radius:24px;padding:0 20px;width:auto;max-width:100%;height:48px;line-height:normal}.mdc-fab--extended .mdc-fab__ripple{border-radius:24px}.mdc-fab--extended .mdc-fab__icon{margin-left:-8px;margin-right:12px}[dir=rtl] .mdc-fab--extended .mdc-fab__icon,.mdc-fab--extended .mdc-fab__icon[dir=rtl]{margin-left:12px;margin-right:-8px}.mdc-fab--extended .mdc-fab__label+.mdc-fab__icon{margin-left:12px;margin-right:-8px}[dir=rtl] .mdc-fab--extended .mdc-fab__label+.mdc-fab__icon,.mdc-fab--extended .mdc-fab__label+.mdc-fab__icon[dir=rtl]{margin-left:-8px;margin-right:12px}.mdc-fab--touch{margin-top:9px;margin-bottom:9px;margin-right:9px;margin-left:9px}.mdc-fab--touch .mdc-fab__touch{position:absolute;top:50%;right:0;height:48px;left:50%;width:48px;transform:translate(-50%, -50%)}.mdc-fab::before{position:absolute;box-sizing:border-box;width:100%;height:100%;top:0;left:0;border:1px solid transparent;border-radius:inherit;content:\"\"}.mdc-fab__label{justify-content:flex-start;text-overflow:ellipsis;white-space:nowrap;overflow-x:hidden;overflow-y:visible}.mdc-fab__icon{transition:transform 180ms 90ms cubic-bezier(0, 0, 0.2, 1);fill:currentColor;will-change:transform}.mdc-fab .mdc-fab__icon{display:inline-flex;align-items:center;justify-content:center}.mdc-fab--exited{transform:scale(0);opacity:0;transition:opacity 15ms linear 150ms, transform 180ms 0ms cubic-bezier(0.4, 0, 1, 1)}.mdc-fab--exited .mdc-fab__icon{transform:scale(0);transition:transform 135ms 0ms cubic-bezier(0.4, 0, 1, 1)}@keyframes mdc-ripple-fg-radius-in{from{animation-timing-function:cubic-bezier(0.4, 0, 0.2, 1);transform:translate(var(--mdc-ripple-fg-translate-start, 0)) scale(1)}to{transform:translate(var(--mdc-ripple-fg-translate-end, 0)) scale(var(--mdc-ripple-fg-scale, 1))}}@keyframes mdc-ripple-fg-opacity-in{from{animation-timing-function:linear;opacity:0}to{opacity:var(--mdc-ripple-fg-opacity, 0)}}@keyframes mdc-ripple-fg-opacity-out{from{animation-timing-function:linear;opacity:var(--mdc-ripple-fg-opacity, 0)}to{opacity:0}}.mdc-fab{--mdc-ripple-fg-size:0;--mdc-ripple-left:0;--mdc-ripple-top:0;--mdc-ripple-fg-scale:1;--mdc-ripple-fg-translate-end:0;--mdc-ripple-fg-translate-start:0;-webkit-tap-highlight-color:rgba(0, 0, 0, 0)}.mdc-fab .mdc-fab__ripple::before,.mdc-fab .mdc-fab__ripple::after{position:absolute;border-radius:50%;opacity:0;pointer-events:none;content:\"\"}.mdc-fab .mdc-fab__ripple::before{transition:opacity 15ms linear, background-color 15ms linear;z-index:1}.mdc-fab.mdc-ripple-upgraded .mdc-fab__ripple::before{transform:scale(var(--mdc-ripple-fg-scale, 1))}.mdc-fab.mdc-ripple-upgraded .mdc-fab__ripple::after{top:0;left:0;transform:scale(0);transform-origin:center center}.mdc-fab.mdc-ripple-upgraded--unbounded .mdc-fab__ripple::after{top:var(--mdc-ripple-top, 0);left:var(--mdc-ripple-left, 0)}.mdc-fab.mdc-ripple-upgraded--foreground-activation .mdc-fab__ripple::after{animation:mdc-ripple-fg-radius-in 225ms forwards, mdc-ripple-fg-opacity-in 75ms forwards}.mdc-fab.mdc-ripple-upgraded--foreground-deactivation .mdc-fab__ripple::after{animation:mdc-ripple-fg-opacity-out 150ms;transform:translate(var(--mdc-ripple-fg-translate-end, 0)) scale(var(--mdc-ripple-fg-scale, 1))}.mdc-fab .mdc-fab__ripple::before,.mdc-fab .mdc-fab__ripple::after{top:calc(50% - 100%);left:calc(50% - 100%);width:200%;height:200%}.mdc-fab.mdc-ripple-upgraded .mdc-fab__ripple::after{width:var(--mdc-ripple-fg-size, 100%);height:var(--mdc-ripple-fg-size, 100%)}.mdc-fab .mdc-fab__ripple::before,.mdc-fab .mdc-fab__ripple::after{background-color:#fff;background-color:var(--mdc-theme-on-secondary, #fff)}.mdc-fab:hover .mdc-fab__ripple::before{opacity:0.08}.mdc-fab.mdc-ripple-upgraded--background-focused .mdc-fab__ripple::before,.mdc-fab:not(.mdc-ripple-upgraded):focus .mdc-fab__ripple::before{transition-duration:75ms;opacity:0.24}.mdc-fab:not(.mdc-ripple-upgraded) .mdc-fab__ripple::after{transition:opacity 150ms linear}.mdc-fab:not(.mdc-ripple-upgraded):active .mdc-fab__ripple::after{transition-duration:75ms;opacity:0.24}.mdc-fab.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.24}.mdc-fab .mdc-fab__ripple{position:absolute;top:0;left:0;width:100%;height:100%;pointer-events:none;overflow:hidden}:host{display:inline-flex;vertical-align:middle;--flow-color-base:var(--flow-color-secondary, #7C4DFF);--flow-color-base-rgb:var(--flow-color-secondary-rgb, 124, 77, 255);--flow-color-contrast:var(--flow-color-secondary-contrast, #ffffff);--flow-color-contrast-rgb:var(\n    --flow-color-secondary-contrast-rgb,\n    255, 255, 255\n  ) !important;--flow-color-shade:var(--flow-color-secondary-shade, #633ecc);--flow-color-tint:var(--flow-color-secondary-tint, #9671ff);--color:var(--flow-color-base);--background-color:var(--flow-color-contrast)}.mdc-fab{color:var(--background-color);background-color:var(--color)}.mdc-fab--checkbox{color:var(--color);background-color:var(--flow-color-background, #ffffff)}.mdc-fab--checked{color:var(--background-color);background-color:var(--color)}.mdc-fab{font-family:var(--flow-font-sans, -apple-system, BlinkMacSystemFont, Segoe UI, Roboto, Helvetica, Arial, sans-serif, Apple Color Emoji, Segoe UI Emoji, Segoe UI Symbol)}.mdc-fab .mdc-fab__icon{width:22px;height:22px;font-size:22px}.mdc-fab.mdc-fab--mini .mdc-fab__icon{width:16px;height:16px;font-size:16px}.mdc-fab.mdc-fab--square:not(.mdc-fab--extended){border-radius:4px}.mdc-fab.mdc-fab--square:not(.mdc-fab--extended) .mdc-fab__ripple{border-radius:4px}.mdc-fab.mdc-fab--square.mdc-fab--extended{border-radius:4px}.mdc-fab.mdc-fab--square.mdc-fab--extended .mdc-fab__ripple{border-radius:4px}";

const FlowFabButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.initialized = false;
    /**
     * Set to `true` to display a smaller FAB.
     */
    this.compact = false;
    /**
     * Set to `true` to display the FAB using the 'square' style. By default,
     * FABs are round.
     */
    this.square = false;
    /**
     * Set to `true` for the FAB to act like a checkbox.
     */
    this.checkbox = false;
    /**
     * The checked state of the FAB. Only applicable if `checkbox` is set to `true`.
     */
    this.checked = false;
    this.handleClick = this.handleClick.bind(this);
  }
  connectedCallback() {
    if (this.initialized) {
      // Handle re-connect to DOM
      this.connect();
    }
  }
  componentDidLoad() {
    this.initialized = true;
    this.connect();
  }
  disconnectedCallback() {
    this.disconnect();
  }
  connect() {
    this.ripple = new component.MDCRipple(this.button);
    this.ripple.unbounded = true;
  }
  disconnect() {
    var _a;
    (_a = this.ripple) === null || _a === void 0 ? void 0 : _a.destroy();
  }
  handleClick() {
    this.checked = this.checkbox && !this.checked;
  }
  render() {
    const { label, icon, color, compact, square, checkbox, checked } = this;
    const hostClasses = Object.assign({}, theme.createColorClasses(color));
    const classes = {
      'mdc-fab': true,
      'mdc-fab--mini': compact,
      'mdc-fab--square': square,
      'mdc-fab--extended': !!label,
      'mdc-fab--checkbox': checkbox,
      'mdc-fab--checked': checked
    };
    return (index.h(index.Host, { class: hostClasses }, index.h("button", { ref: (el) => (this.button = el), class: classes, onClick: this.handleClick }, index.h("div", { class: "mdc-fab__ripple" }), index.h("flow-icon", { class: "mdc-fab__icon", icon: icon }), label ? index.h("span", { class: "mdc-fab__label" }, label) : '')));
  }
};
FlowFabButton.style = fabCss;

const fabGroupCss = ":host{position:relative;box-sizing:border-box}:host *,:host *:before,:host *:after{box-sizing:inherit}:host{display:inline-flex;width:48px;height:48px;line-height:48px;vertical-align:middle}::slotted(*){pointer-events:none}.main-fab{pointer-events:auto}:host([open]) ::slotted(*){pointer-events:auto}.fab-container{position:absolute;display:flex;pointer-events:none;align-items:center;line-height:normal;transition:var(--flow-transition-medium, 250ms) gap ease;gap:0}.fab-sub-container{display:flex;opacity:0;align-items:center;transition:var(--flow-transition-medium, 250ms) opacity ease;transition:var(--flow-transition-medium, 250ms) gap ease;gap:0}.fab-container.fab-container--up{bottom:0;flex-direction:column-reverse}.fab-container.fab-container--up .fab-sub-container{flex-direction:column-reverse}.fab-container.fab-container--down{top:0;flex-direction:column}.fab-container.fab-container--down .fab-sub-container{flex-direction:column}.fab-container.fab-container--left{right:0;flex-direction:row-reverse}.fab-container.fab-container--left .fab-sub-container{flex-direction:row-reverse}.fab-container.fab-container--right{left:0;flex-direction:row}.fab-container.fab-container--right .fab-sub-container{flex-direction:row}.fab-container.fab-container--open{gap:5px}.fab-container.fab-container--open .fab-sub-container{opacity:1;overflow:visible;gap:5px}";

const FabGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.initialized = false;
    /**
     * Set this attribute to `true` to force the FAB group to open. The open state will
     * be toggled automatically when the main FAB is clicked.
     */
    this.open = false;
    /**
     * Specify the direction in which to expand buttons when the FAB group is opened.
     */
    this.direction = 'up';
    /**
     * The Flo.w context ID to use for application state.
     */
    this.flowContext = 'default';
    this.handleClick = this.handleClick.bind(this);
  }
  connectedCallback() {
    if (this.initialized) {
      // Handle re-connect to DOM
      this.connect();
    }
  }
  componentDidLoad() {
    this.initialized = true;
    this.connect();
  }
  disconnectedCallback() {
    this.disconnect();
  }
  connect() {
    this.subscribe();
  }
  disconnect() {
    this.unsubscribe();
  }
  async subscribe() {
    this.unsubscribe();
    if (this.selectionState) {
      const context = await contextRegistry.globalContextRegistry.getContext(this.flowContext);
      this.subscription = context.state.toStream(this.selectionState, true).subscribe(value => {
        if (Array.isArray(value)) {
          this.getAllSubFABs().forEach(fab => (fab.checked = value.indexOf(fab.value) > -1));
        }
      });
    }
  }
  unsubscribe() {
    if (this.subscription) {
      this.subscription.unsubscribe();
      this.subscription = undefined;
    }
  }
  async handleClick(event) {
    const target = event.target;
    if (target.classList.contains('main-fab')) {
      // Click on main FAB - toggle open state
      this.open = !this.open;
    }
    else {
      // Click on sub FAB - update checked status
      const subFABs = this.getAllSubFABs();
      const state = subFABs.reduce((accum, fab) => {
        if (fab.checked) {
          accum.push(fab.value);
        }
        return accum;
      }, []);
      if (this.selectionState) {
        const context = await contextRegistry.globalContextRegistry.getContext(this.flowContext);
        let stateValues = context.state.get(this.selectionState) || [];
        // Remove all values for this FAB group
        const fabValues = subFABs.map(el => el.value);
        stateValues = stateValues.filter(val => fabValues.indexOf(val) === -1);
        // Add selected values for this FAB group
        stateValues = stateValues.concat(state);
        context.state.set(this.selectionState, stateValues);
      }
    }
  }
  getAllSubFABs() {
    var _a;
    const slot = (_a = this.subFABContainer) === null || _a === void 0 ? void 0 : _a.querySelector('slot');
    return slot ? slot.assignedElements({ flatten: true }).map(el => this.findFab(el)).filter(el => !!el) : [];
  }
  findFab(el) {
    var _a;
    const selector = 'flow-fab';
    // The button could be the target element or a child of it (e.g. a dropdown or tooltip anchor)
    return (_a = el.closest(selector)) !== null && _a !== void 0 ? _a : el.querySelector(selector);
  }
  render() {
    const containerClasses = {
      'fab-container': true,
      'fab-container--open': this.open,
      // Directions
      'fab-container--up': this.direction === 'up',
      'fab-container--down': this.direction === 'down',
      'fab-container--left': this.direction === 'left',
      'fab-container--right': this.direction === 'right'
    };
    return (index.h(index.Host, null, index.h("div", { class: containerClasses, onClick: this.handleClick }, index.h("flow-fab", { class: "main-fab", icon: this.icon }), index.h("div", { ref: el => (this.subFABContainer = el), class: "fab-sub-container" }, index.h("slot", null)))));
  }
  static get watchers() { return {
    "selectionState": ["subscribe"]
  }; }
};
FabGroup.style = fabGroupCss;

exports.flow_button = Button;
exports.flow_fab = FlowFabButton;
exports.flow_fab_group = FabGroup;
