import { html } from 'lit-html';

export default {
  title: 'Components|flow-context',
  component: 'flow-context'
};

const contextInitialized = {
  handleEvent(ev) {
    const context = ev.detail;
    const outputEl = document.getElementById('output');
    outputEl.textContent = `
Context initialized...
${JSON.stringify({ id: context.id, host: context.host, apiKey: context.apiKey }, null, 2)}
  `;
  }
};

export const basic = () => html`
  <flow-context api-key="b6b77cc4-904a-46d1-aa0f-3bf3848ce4c7" @flowContextInitialized="${contextInitialized}">
  </flow-context>
  <pre id="output"><pre>
`;
