/*!
 * (C) Emu Analytics
 */
import { Component, Host, h, Element } from '@stencil/core';
/**
 * @status 1.0
 * @status stable
 */
export class FlowListGroup {
  componentWillLoad() { }
  componentDidLoad() { }
  disconnectedCallback() { }
  render() {
    const classes = {
      ['mdc-list-group']: true
    };
    return h(Host, { class: classes },
      h("slot", null));
  }
  static get is() { return "flow-list-group"; }
  static get originalStyleUrls() { return {
    "$": ["list-group.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["list-group.css"]
  }; }
  static get elementRef() { return "el"; }
}
