/*!
 * (C) Emu Analytics
 */
import { r as registerInstance, h, e as Host, g as getElement } from './index-abc3ebe6.js';

const listGroupCss = ":host{position:relative;box-sizing:border-box}:host *,:host *:before,:host *:after{box-sizing:inherit}flow-list-group{display:block}";

const FlowListGroup = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
  }
  componentWillLoad() { }
  componentDidLoad() { }
  disconnectedCallback() { }
  render() {
    const classes = {
      ['mdc-list-group']: true
    };
    return h(Host, { class: classes }, h("slot", null));
  }
  get el() { return getElement(this); }
};
FlowListGroup.style = listGroupCss;

export { FlowListGroup as flow_list_group };
