import { PredefinedColor } from '../../utils/theme';
/**
 * @since 2.1
 * @status stable
 *
 * @slot - The badge's content.
 */
export declare class Badge {
  /**
   * The color of the component. Colors are taken from the application palette.
   */
  color: PredefinedColor;
  /**
   * Set to true to draw a pill-style badge with rounded corners.
   */
  pill: boolean;
  /** Set to true to make the badge pulse. */
  pulse: boolean;
  render(): any;
}
