import { ComponentWillLoad, ComponentDidLoad } from '../../../stencil-public-runtime';
/**
 * @since 1.0
 * @status stable
 */
export declare class FlowListDivider implements ComponentWillLoad, ComponentDidLoad {
  el: HTMLElement;
  /**
   * Set to `true` to pad the divider to align with the list text.
   */
  padded: boolean;
  /**
   * Set to `true` to inset the divider past the list text.
   */
  inset: boolean;
  /**
   * Set to display text above the divider line.
   */
  text: string;
  componentWillLoad(): void;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  render(): any;
}
