/**
 * @since 1.1
 * @status stable
 *
 * @slot - The tab panel's content.
 *
 * @part panel - The panel's container DIV element.
 */
export declare class TabPanel {
  componentId: string;
  host: HTMLFlowTabPanelElement;
  /** The tab panel's name. */
  name: string;
  /** Set to `true` to show the tab panel. */
  active: boolean;
  render(): any;
}
