import { Failure } from 'parsimmon';
/**
 * @internal
 */
export declare class ParseError extends Error {
  static formatMessage(source: string, result: Failure): string;
  readonly source: string;
  readonly expected: string;
  readonly line: number;
  readonly column: number;
  readonly offset: number;
  constructor(source: string, result: Failure);
}
