export interface Duration {
  millis: number;
  duration: number;
  unit: string;
}
export declare function parse(str: string): Duration | null;
export declare namespace parse {
  var millis: number;
  var millisecond: number;
  var ms: number;
  var second: number;
  var sec: number;
  var s: number;
  var minute: number;
  var min: number;
  var m: number;
  var hour: number;
  var hr: number;
  var h: number;
  var day: number;
  var d: number;
  var week: number;
  var wk: number;
  var w: number;
  var M: number;
  var month: number;
  var year: number;
  var yr: number;
  var y: number;
}
