/*!
 * (C) Emu Analytics
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-df77e04f.js');
const appGlobals = require('./app-globals-2caf1d54.js');
require('./flow-core-context-9645d5e4.js');
require('./debug-490602eb.js');

/*
 Stencil Client Patch Esm v2.17.3 | MIT Licensed | https://stenciljs.com
 */
const patchEsm = () => {
    return index.promiseResolve();
};

const defineCustomElements = (win, options) => {
  if (typeof window === 'undefined') return Promise.resolve();
  return patchEsm().then(() => {
  appGlobals.globalScripts();
  return index.bootstrapLazy([["flow-gauge.cjs",[[1,"flow-gauge",{"color":[1],"duration":[2],"flowContext":[1,"flow-context"],"format":[1],"heading":[1],"icon":[1],"units":[1],"value":[1],"currentIcon":[32]}]]],["flow-list_5.cjs",[[4,"flow-list-header",{"color":[1],"icon":[1],"collapsible":[4],"open":[1540]}],[4,"flow-list-item",{"activated":[4],"checked":[4],"disabled":[4],"color":[1],"icon":[1],"lineOne":[1,"line-one"],"lineTwo":[1,"line-two"],"selected":[4],"trailingIcon":[1,"trailing-icon"],"type":[1],"value":[8]}],[4,"flow-list",{"singleSelection":[4,"single-selection"],"twoLine":[4,"two-line"],"selectionState":[1,"selection-state"],"flowContext":[1,"flow-context"],"setSelectedIndex":[64],"setSelected":[64]}],[0,"flow-list-divider",{"padded":[4],"inset":[4],"text":[1]}],[4,"flow-list-group"]]],["flow-tab_3.cjs",[[1,"flow-tab-group",{"placement":[1],"canScrollHorizontally":[32],"show":[64]}],[1,"flow-tab",{"panel":[513],"active":[516],"disabled":[516],"setFocus":[64],"removeFocus":[64]}],[1,"flow-tab-panel",{"name":[1],"active":[4]}]]],["flow-drawer_2.cjs",[[1,"flow-drawer",{"open":[516],"position":[1],"sideTab":[4,"side-tab"]}],[1,"flow-drawer-container",{"_drawerClasses":[1040]},[[0,"flowDrawerOpening","updateDrawerState"],[0,"flowDrawerClosing","updateDrawerState"],[0,"flowDrawerOpened","updateDrawerState"],[0,"flowDrawerClosed","updateDrawerState"]]]]],["flow-chip.cjs",[[1,"flow-chip",{"color":[1],"size":[513],"pill":[4],"clearable":[4]}]]],["flow-input.cjs",[[17,"flow-input",{"color":[1],"type":[1],"label":[1],"value":[1025],"prefixText":[1,"prefix-text"],"suffixText":[1,"suffix-text"],"icon":[1],"trailingIcon":[1,"trailing-icon"],"name":[513],"disabled":[516]}]]],["flow-map_6.cjs",[[4,"flow-map",{"_map":[1040],"busyIndicator":[4,"busy-indicator"],"center":[1],"flowContext":[1,"flow-context"],"mapStyle":[513,"map-style"],"sync":[4],"fixedPosition":[4,"fixed-position"],"trackResize":[4,"track-resize"],"featureClickTolerance":[2,"feature-click-tolerance"],"isFeatureHovered":[32],"drawerClasses":[32],"showBusyIndicator":[32],"getMap":[64],"zoomBy":[64],"export":[64],"setFeatureState":[64],"removeFeatureState":[64],"openPopup":[64],"closeAllPopups":[64]}],[0,"flow-map-data-join",{"_datajoin":[16],"name":[1],"foreignKey":[1,"foreign-key"],"clear":[4],"sourceLayer":[1,"source-layer"],"src":[1]}],[0,"flow-map-data-source",{"_datasource":[1040],"name":[1],"type":[1],"cluster":[4],"clusterRadius":[2,"cluster-radius"],"clusterMaxZoom":[2,"cluster-max-zoom"],"limit":[2],"featureId":[1,"feature-id"],"apiKey":[1,"api-key"],"sourceLayer":[1,"source-layer"],"selectionMode":[1,"selection-mode"],"selectionState":[1,"selection-state"],"selectionFeatureState":[1,"selection-feature-state"],"selectionClear":[8,"selection-clear"],"selectionGroup":[8,"selection-group"],"selectionPopup":[1,"selection-popup"],"src":[1],"closeAllPopups":[64],"closePopup":[64]}],[0,"flow-map-icon",{"name":[1],"src":[1],"width":[2],"height":[2],"recolor":[4],"flowContext":[1,"flow-context"],"pixelDensity":[2,"pixel-density"]}],[0,"flow-map-layer",{"_layer":[1040],"name":[1],"type":[1],"source":[1],"sourceLayer":[1,"source-layer"],"filter":[1],"layerStyle":[1,"layer-style"],"interactive":[4],"above":[1],"below":[1],"metadata":[8],"minZoom":[2,"min-zoom"],"maxZoom":[2,"max-zoom"]}],[0,"flow-map-parameter",{"_parameter":[1040],"name":[1],"value":[1],"required":[4]}]]],["flow-data-column_2.cjs",[[1,"flow-data-table",{"data":[1],"flowContext":[1,"flow-context"],"rowSelect":[4,"row-select"],"fullRowSelect":[4,"full-row-select"],"rowId":[1,"row-id"],"rowType":[1,"row-type"],"compact":[4],"stickyHeader":[4,"sticky-header"],"showHeader":[4,"show-header"],"noScroll":[4,"no-scroll"],"wrap":[4],"columnDefs":[32],"_data":[32],"selectedRows":[64],"setSelectedRows":[64]}],[0,"flow-data-column",{"name":[513],"property":[513],"align":[513],"sortable":[516],"format":[513],"width":[1],"allowHtml":[4,"allow-html"]}]]],["flow-busy-overlay.cjs",[[1,"flow-busy-overlay",{"color":[1],"size":[1],"busy":[513],"overlayParent":[4,"overlay-parent"],"flowContext":[1,"flow-context"],"_busy":[32],"showProgress":[32]}]]],["flow-checkbox_4.cjs",[[1,"flow-checkbox",{"color":[1],"align":[1],"label":[1],"value":[1],"checked":[1540],"name":[1],"disabled":[516],"indeterminate":[516],"setFocus":[64],"removeFocus":[64]}],[1,"flow-checkbox-group",{"value":[1040],"disabled":[1540],"selectionState":[1,"selection-state"],"flowContext":[1,"flow-context"]},[[0,"flowChange","onFlowChange"]]],[1,"flow-radio",{"color":[1],"align":[1],"label":[1],"value":[1],"name":[513],"checked":[1540],"disabled":[516],"setFocus":[64],"removeFocus":[64]}],[1,"flow-radio-group",{"value":[1537],"disabled":[1540],"selectionState":[1,"selection-state"],"flowContext":[1,"flow-context"]},[[0,"flowChange","onFlowChange"]]]]],["flow-chart_3.cjs",[[1,"flow-chart",{"_chart":[16],"chartSpec":[1,"chart-spec"],"flowContext":[1,"flow-context"],"height":[2],"width":[2],"tooltip":[4]}],[0,"flow-chart-data",{"_chartData":[16],"data":[1],"name":[1],"x":[1],"y":[1]}],[0,"flow-chart-signal",{"_chartSignal":[16],"name":[1],"value":[1]}]]],["flow-badge.cjs",[[1,"flow-badge",{"color":[1],"pill":[4],"pulse":[4]}]]],["flow-context.cjs",[[1,"flow-context",{"apiKey":[1,"api-key"],"context":[16],"contextId":[1,"context-id"],"host":[1]}]]],["flow-map-popup.cjs",[[0,"flow-map-popup",{"name":[1],"closeButton":[4,"close-button"],"closeOnClick":[4,"close-on-click"],"closeOnMove":[4,"close-on-move"],"maxWidth":[1,"max-width"],"trackLocation":[8,"track-location"],"fireTrackImmediately":[4,"fire-track-immediately"],"popupClass":[1,"popup-class"]}]]],["flow-tooltip.cjs",[[1,"flow-tooltip",{"tipText":[1,"tip-text"],"position":[1],"disabled":[4],"offset":[2],"open":[1540],"trigger":[1],"for":[1],"show":[64],"hide":[64]}]]],["flow-progress-bar.cjs",[[1,"flow-progress-bar",{"color":[1],"indeterminate":[4],"value":[2]}]]],["flow-progress-ring.cjs",[[1,"flow-progress-ring",{"color":[1],"indeterminate":[4],"autoShow":[4,"auto-show"],"size":[1],"value":[2],"width":[32],"radius":[32],"circum":[32],"strokeWidth":[32]}]]],["flow-dialog_2.cjs",[[1,"flow-dialog",{"escapeKeyAction":[1,"escape-key-action"],"scrimClickAction":[1,"scrim-click-action"],"open":[64],"close":[64],"waitUntilClosed":[64]}],[1,"flow-value",{"duration":[2],"flowContext":[1,"flow-context"],"format":[1],"value":[1]}]]],["flow-icon.cjs",[[1,"flow-icon",{"ariaLabel":[1537,"aria-label"],"color":[1],"icon":[520],"size":[1],"lazy":[4],"svgContent":[32],"isVisible":[32]}]]],["flow-button_3.cjs",[[1,"flow-fab-group",{"icon":[1],"open":[516],"direction":[1],"selectionState":[1,"selection-state"],"flowContext":[1,"flow-context"]}],[1,"flow-fab",{"color":[1],"compact":[4],"icon":[1],"label":[1],"square":[4],"checkbox":[4],"checked":[516],"value":[513]}],[17,"flow-button",{"color":[1],"compact":[4],"disabled":[4],"label":[1],"icon":[1],"iconButton":[4,"icon-button"],"outlined":[4],"solid":[4],"trailingIcon":[4,"trailing-icon"],"href":[1],"target":[1],"download":[1],"submit":[4]}]]],["flow-date-time-picker_2.cjs",[[1,"flow-timer",{"enablePlay":[4,"enable-play"],"flowContext":[1,"flow-context"],"majorStep":[1,"major-step"],"minorStep":[1,"minor-step"],"running":[1540],"timerState":[1,"timer-state"],"timerStateFormat":[1,"timer-state-format"],"updateDelay":[1,"update-delay"],"updateInterval":[1,"update-interval"],"value":[1537],"disabled":[516],"utc":[4],"timezone":[1],"static":[4],"fixed":[4],"position":[1],"currentMoment":[32]}],[1,"flow-date-time-picker",{"mode":[1],"color":[1],"border":[4],"openOnClick":[4,"open-on-click"],"enableSeconds":[4,"enable-seconds"],"inline":[4],"format":[1],"minDate":[1,"min-date"],"maxDate":[1,"max-date"],"minuteIncrement":[2,"minute-increment"],"position":[1],"static":[4],"fixed":[4],"disabled":[4],"clockMode":[1,"clock-mode"],"placeholder":[1],"value":[1537],"utc":[4],"timezone":[1],"open":[64],"close":[64]}]]]], options);
  });
};

exports.defineCustomElements = defineCustomElements;
