import { html } from 'lit-html';

export default {
  title: 'Components|flow-gauge',
  component: 'flow-gauge'
};

const contextInitialized = {
  handleEvent(ev) {
    const context = ev.detail;
  }
};

export const basic = () => html`
  <flow-context @flowContextInitialized="${contextInitialized}"></flow-context>
  <flow-gauge heading="Basic Gauge" value="10" units="km/h" format="0.1f"></flow-gauge>
`;
