/*!
 * (C) Emu Analytics
 */
import { ERRORS } from './constants';
/**
 * @internal
 */
export class QueryTimeoutError extends Error {
  constructor(queryId) {
    super(`Query timed out: ${queryId}`);
    this.queryId = queryId;
    this.name = ERRORS.QueryTimeoutError;
  }
}
