/*!
 * (C) Emu Analytics
 */
import { version } from '../package.json';
import { FlowCoreContext } from './core/context/flow-core-context';
export default function globalInit() {
  console.log(`Flo.w RDF initialized (version ${version})`);
  const context = new FlowCoreContext('', '', '');
  const a = context.state.get('abbrTime');
  context.state.compute('abbrTime', state => {
    return state.time + 'f';
  });
}
