/*!
 * (C) Emu Analytics
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const listGroupCss = ":host{position:relative;box-sizing:border-box}:host *,:host *:before,:host *:after{box-sizing:inherit}flow-list-group{display:block}";

const FlowListGroup$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
  }
  componentWillLoad() { }
  componentDidLoad() { }
  disconnectedCallback() { }
  render() {
    const classes = {
      ['mdc-list-group']: true
    };
    return h(Host, { class: classes }, h("slot", null));
  }
  get el() { return this; }
  static get style() { return listGroupCss; }
}, [4, "flow-list-group"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["flow-list-group"];
  components.forEach(tagName => { switch (tagName) {
    case "flow-list-group":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, FlowListGroup$1);
      }
      break;
  } });
}

const FlowListGroup = FlowListGroup$1;
const defineCustomElement = defineCustomElement$1;

export { FlowListGroup, defineCustomElement };
