/*!
 * (C) Emu Analytics
 */
import { g as globalContextRegistry } from './context-registry-6b74a3a3.js';
export { C as ContextRegistry, D as DEFAULT_CONTEXT_ID, g as globalContextRegistry } from './context-registry-6b74a3a3.js';
export { c as FLOW_CONTEXT_ATTR, b as FLOW_CONTEXT_TAG, F as FlowCoreContext, a as FlowQuery, S as StateStore } from './flow-core-context-3daf3594.js';
export { F as FlowCoreDataSource, q as FlowCoreMap, r as FlowCoreMapCompositeLayer, t as FlowCoreMapLayer, v as FlowCoreMapPopup, w as FlowCoreParameter, k as escapeMaplibreString, o as expandCircleRadius, a as expandCompositeCircleLayer, b as expandCompositeFillLayer, e as expandCompositeLayer, d as expandCompositeLayerFlowStyle, c as expandCompositeLineLayer, n as expandLabelSize, f as expandPropertyValue, m as expandStrokeWidth, s as isCompositeLayer, h as isDataDrivenProperty, g as isExpressionProperty, i as isLiteralProperty, u as isMaplibreLayer, j as isSupportedLayerType, l as labelLayerForCompositeLayer, p as orderByArrayIndex } from './flow-core-parameter-3d30dfa3.js';
export { c as flowComputed, d as flowObservable } from './debug-a598c5ea.js';
import './debounce-6de229df.js';
import './index-6c3bd734.js';
import './ensure-array-ffbb7493.js';
import './random-id-d84012dc.js';

/**
 * A global instance of [ContextRegistry].
 *
 *
 * This should be client code as the entry point to the Flo.w RDF JavaScript API.
 */
const flow = globalContextRegistry;

export { flow };
