export interface ColumnDef {
  name: string;
  property: string;
  width: string;
  align: 'right' | 'left' | 'center';
  sortable: boolean;
  allowHtml: boolean;
  formatter: FormatFunction;
}
export interface RowSelectionChangedEventDetail {
  rowId: number | string | null;
  rowIndex: number;
  selected: boolean;
}
export declare type SortValue = 'ascending' | 'descending';
export interface SortActionEventDetail {
  columnId: string | null;
  columnIndex: number;
  headerCell: HTMLElement;
  sortValue: SortValue;
}
export declare type FormatFunction = (data: any) => string;
