import { EventEmitter, ComponentWillLoad } from '../../../stencil-public-runtime';
import { FlowDrawChangedEvent } from './constants';
import { HTMLStencilElement } from '../../../stencil-public-runtime';
/**
 * @status stable
 */
export declare class FlowDrawerContainer implements ComponentWillLoad {
  private startDrawerOpen;
  private endDrawerOpen;
  private startDrawerOpening;
  private endDrawerOpening;
  private startDrawerClosing;
  private endDrawerClosing;
  el: HTMLStencilElement;
  /** @internal */
  _drawerClasses: {};
  /**
   * Emitted when the container drawer state changes.
   */
  drawerChanged: EventEmitter<FlowDrawChangedEvent>;
  componentWillLoad(): void;
  disconnectedCallback(): void;
  private updateDrawerState;
  render(): any;
}
