import { ComponentDidLoad } from '../../stencil-public-runtime';
import { PredefinedColor } from '../../utils/theme';
/**
 * @since 1.0
 * @status stable
 */
export declare class FlowProgressBar implements ComponentDidLoad {
  private mdcProgressBar;
  private mdcProgressBarEl;
  /**
   * The color of the progress indicator. Colors are taken from the application palette.
   */
  color?: PredefinedColor;
  /**
   * Set to `true` to show an indeterminate progress bar.
   */
  indeterminate: boolean;
  /**
   * Set to a value between 0 and 1 to indicate current progress.
   */
  value: number;
  updateProgress(): void;
  componentDidLoad(): void;
  render(): any;
}
