export declare type PredefinedColor = 'primary' | 'secondary' | 'success' | 'warning' | 'danger' | 'gray';
export declare type Color = PredefinedColor | string;
export interface CssClassMap {
  [className: string]: boolean;
}
export declare const createColorClasses: (color: Color | undefined | null) => CssClassMap | undefined;
