export declare const isUndefined: (val: unknown) => val is undefined;
export declare const isNull: (val: unknown) => val is null;
export declare const isNil: (val: unknown) => val is null;
export declare const isDefined: <T>(val: T) => val is Exclude<T, null>;
export declare const isString: (val: unknown) => val is string;
export declare const hasLength: (val: unknown) => boolean;
export declare const isStringFull: (val: unknown) => val is string;
export declare const isArray: (val: unknown) => val is unknown[];
export declare const isArrayFull: (val: unknown) => val is unknown[];
export declare const isArrayStrings: (val: unknown) => val is string[];
export declare const isObject: (val: unknown) => val is object;
export declare const isObjectFull: (val: unknown) => boolean;
export declare const isNumber: (val: unknown) => val is number;
export declare const isFalse: (val: unknown) => val is false;
export declare const isTrue: (val: unknown) => val is true;
export declare const isIn: (val: unknown, arr: any[]) => boolean;
export declare const isBoolean: (val: unknown) => val is boolean;
export declare const isNumeric: (val: unknown) => boolean;
export declare const isDate: (val: unknown) => val is Date;
export declare const isValue: (val: unknown) => boolean;
export declare const hasValue: (val: unknown) => boolean;
export declare const isFunction: (val: unknown) => val is Function;
export declare function isPlainObject(o: unknown): boolean;
export declare function isURL(val: unknown): val is string;
