import { FlowComputed } from '../core/state-store';
declare type IsStrictlyAny<T> = (T extends never ? true : false) extends false ? false : true;
declare type HasIndexSignature<T> = T extends {
  [k in 'FlowRDFdummyval']?: any;
} ? true : false;
declare type PathImpl<T, Key extends keyof T> = Key extends string ? IsStrictlyAny<T[Key]> extends true ? never : HasIndexSignature<T[Key]> extends true ? never : T[Key] extends Record<string, any> ? `${Key}.${PathImpl<T[Key], Exclude<keyof T[Key], keyof any[]>> & string}` | `${Key}.${Exclude<keyof T[Key], keyof any[]> & string}` : never : never;
export declare type Path<T> = PathImpl<T, keyof T> | keyof T;
export declare type PathValue<T, P extends Path<T>> = P extends `${infer Key}.${infer Rest}` ? Key extends keyof T ? Rest extends Path<T[Key]> ? PathValue<T[Key], Rest> : never : never : P extends keyof T ? T[P] extends FlowComputed<infer TComputed> ? TComputed : T[P] : never;
export {};
